%define anolis_release 1

Name:           python-virtualenv
Version:        20.17.0
Release:        %{anolis_release}%{?dist}
Summary:        Tool to create isolated Python environments

License:        MIT
URL:            http://pypi.python.org/pypi/virtualenv
Source0:        %{pypi_source virtualenv}

# Add /usr/share/python-wheels to extra_search_dir
Patch1:         rpm-wheels.patch

BuildArch:      noarch

BuildRequires:  python3-devel
BuildRequires:  python3-distlib
BuildRequires:  python3-filelock
BuildRequires:  python3-platformdirs

%bcond_without tests
%if %{with tests}
BuildRequires:  fish
BuildRequires:  tcsh
BuildRequires:  gcc
BuildRequires:  python3-flaky
BuildRequires:  python3-packaging
BuildRequires:  python3-pytest
BuildRequires:  python3-pytest-mock
BuildRequires:  python3-pytest-randomly
BuildRequires:  python3-pytest-timeout
%endif

# RPM installed wheels
BuildRequires:  %{python_wheel_pkg_prefix}-pip-wheel
BuildRequires:  %{python_wheel_pkg_prefix}-setuptools-wheel
BuildRequires:  %{python_wheel_pkg_prefix}-wheel-wheel

%description
virtualenv is a tool to create isolated Python environments. virtualenv
is a successor to workingenv, and an extension of virtual-python. It is
written by Ian Bicking, and sponsored by the Open Planning Project. It is
licensed under an MIT-style permissive license.


%package -n     python3-virtualenv
Summary:        Tool to create isolated Python environments

# This virtualenv requires the "venv" install scheme on Pythons
# where we patch "posix_prefix".
# Explicitly conflict with Pythons where we don't have it yet.
Conflicts:      python3.10 < 3.10.0-3

Obsoletes:      python3-virtualenv-python26 < 16.6
%{?python_provide:%python_provide python3-virtualenv}

# Provide "virtualenv" for convenience
Provides:       virtualenv = %{version}-%{release}

# RPM installed wheels
Requires:       %{python_wheel_pkg_prefix}-pip-wheel
Requires:       %{python_wheel_pkg_prefix}-setuptools-wheel
Requires:       %{python_wheel_pkg_prefix}-wheel-wheel

%description -n python3-virtualenv
virtualenv is a tool to create isolated Python environments. virtualenv
is a successor to workingenv, and an extension of virtual-python. It is
written by Ian Bicking, and sponsored by the Open Planning Project. It is
licensed under an MIT-style permissive license

%package -n     python3-virtualenv-doc
Summary:        Documentation for python virtualenv
Requires:       python3-virtualenv = %{version}-%{release}

%description -n python3-virtualenv-doc
Documentation for python virtualenv.

%prep
%autosetup -p1 -n virtualenv-%{version}
sed -i -e "1s|#!/usr/bin/env python||" tasks/update_embedded.py

# Remove the wheels provided by RPM packages
rm src/virtualenv/seed/wheels/embed/pip-*
rm src/virtualenv/seed/wheels/embed/setuptools-*
rm src/virtualenv/seed/wheels/embed/wheel-*

test ! -f src/virtualenv/seed/embed/wheels/*.whl

# Replace hardcoded path from rpm-wheels.patch by %%{python_wheel_dir}
sed -i "s|/usr/share/python-wheels|%{python_wheel_dir}|" src/virtualenv/util/path/_system_wheels.py

%generate_buildrequires
%pyproject_buildrequires

%build
# Build code
%pyproject_wheel

%install
%pyproject_install

%if %{with tests}
%check
mkdir tmp_path
ln -s $(realpath %{__python3}) tmp_path/python
export PATH="$(pwd)/tmp_path:$PATH"
unset SOURCE_DATE_EPOCH

# Skip tests which requires internet or some extra dependencies
# Requires internet:
# - test_download_*
# Uses disabled functionalities around bundled wheels:
# - test_wheel_*
# - test_seed_link_via_app_data
# - test_base_bootstrap_via_pip_invoke
# - test_acquire.py (whole file)
# - test_bundle.py (whole file)
# Uses disabled functionalities around automatic updates:
# - test_periodic_update.py (whole file)
# Requires Python 2:
# - test_py_pyc_missing
PIP_CERT=/etc/pki/tls/certs/ca-bundle.crt \
%pytest -vv -k "not test_bundle and \
                not test_acquire and \
                not test_periodic_update and \
                not test_wheel_ and \
                not test_download_ and \
                not test_base_bootstrap_via_pip_invoke and \
                not test_seed_link_via_app_data and \
                not test_py_pyc_missing"

rm -r tmp_path
%endif

%files -n python3-virtualenv
%license LICENSE
%{_bindir}/virtualenv
%{python3_sitelib}/virtualenv/
%{python3_sitelib}/virtualenv-%{version}.dist-info/

%files -n python3-virtualenv-doc
%doc docs/*rst README.md

%changelog
* Wed Feb 01 2023 mgb01105731 <mgb01105731@alibaba-inc.com> - 20.17.0-1
- update to version 20.17.0

* Tue Jan 03 2023 mgb01105731 <mgb01105731@alibaba-inc.com> - 20.16.7-1
- update to version 20.16.7

* Thu Oct 13 2022 happy_orange <songnannan@linux.alibaba.com> - 20.16.5-3
- change the python dist for sysom

* Thu Oct 13 2022 happy_orange <songnannan@linux.alibaba.com> - 20.16.5-2
- add virtualenv-3 binary for sysom

* Thu Oct 13 2022 happy_orange <songnannan@linux.alibaba.com> - 20.16.5-1
- Init pacakge from upstream
